#include "TCPSession.h"

TCPSession::TCPSession(io_service &service) : socket(service)
{
}

std::future<void> TCPSession::Connect(const char *host, unsigned short port)
{
	return when(socket.get_io_service(), this, &TCPSession::Connect, host, port);
}

std::future<void> TCPSession::Disconnect()
{
	return when(socket.get_io_service(), this, &TCPSession::Disconnect);
}

void TCPSession::Connect(yield_context &yield, const char *host, unsigned short port)
{
	host_ = host;
	tcp_query _query(host_, std::to_string(port), tcp_query::canonical_name);
	tcp_resolver _resolver{ socket.get_io_service() };
	auto _iterator = _resolver.async_resolve(_query, yield);
	boost::asio::async_connect(socket, _iterator,
		make_connect_condition(_iterator->endpoint(), this), yield);
}

void TCPSession::Disconnect(yield_context &yield)
{
	if (socket.is_open())
	{
		socket.shutdown(tcp_socket::shutdown_both);
		socket.close();
	}
}
